function showAppItemNew(datos) {
    if (datos.length == 0) {
        $("#apps").append(texto_app_no_found);
    }
    $.each(datos, function (i, item) {
        // if (item.category.id == global.category || global.category == 0) {
        $.each(item.packages_by_project, function (i, pkgs) {
            if (pkgs.project.name == global.project) {
                $("#apps").append(renderApp(item));
                updateStatus(
                    item.name,
                    pkgs.packages_to_install.join(" "),
                    item.level.id
                );
            }
        });
        // }
    });
    $(".collapsible").collapsible(); // FIXME
    // Escondemos el spinner referente a la carga de Apps:
    $("#preload-next").hide();
}

function showAppItem(data) {
    if (data.results.length == 0) {
        $("#apps").append(texto_app_no_found);
    }
    $.each(data.results, function (i, item) {
        if (item.category.id == global.category || global.category == 0) {
            $.each(item.packages_by_project, function (i, pkgs) {
                if (pkgs.project.name == global.project) {
                    $("#apps").append(renderApp(item));
                    updateStatus(
                        item.name,
                        pkgs.packages_to_install.join(" "),
                        item.level.id
                    );
                }
            });
        }
    });
    $(".collapsible").collapsible(); // FIXME
}

function waitForFlagApps() {
    // Función que espera que consultarListaApps() termine de obtner la lista de Apss disponibles en Migasfree
    return new Promise(resolve => {
        const interval = setInterval(() => {
            if (global.flag_apps === true) {
                clearInterval(interval);
                resolve();
            }
        }, 100); // Comprueba cada 100 ms
    });
}

async function queryAppsPage(url) {
    await waitForFlagApps();
    if (global.flag_apps) {
        global.flag_apps = false;
        $.ajax({
            url,
            type: "GET",
            beforeSend: addTokenHeader,
            data: {},
            success(data) {
                $.each(data.results, function (i, item) {
                    $.each(item.packages_by_project, function (i, pkgs) {
                        if (pkgs.project.name == global.project) {
                            global.packages += " " + pkgs.packages_to_install.join(" ");
                        }
                    });
                });

                global.packagesInstalled = installedPkgs(global.packages);

                showAppItem(data);

                if (data.next) {
                    var options = [
                        {
                            selector: "footer",
                            offset: 0,
                            callback() {
                                if (data.next) {
                                    queryAppsPage(data.next);
                                }
                            },
                        },
                    ];
                    Materialize.scrollFire(options);
                } else {
                    $("#preload-next").hide();
                }
                global.flag_apps = true;
            },
            error(jqXHR, textStatus, errorThrown) {
                show_err(jqXHR.responseText);
            },
        });
    }
}

async function queryAppsIni() {
    $("#apps").html("");
    $("#preload-next").show();
    global.packages = "";

    var url = "";
    var categoryFilter = "";
    if (global.category != 0) {
        categoryFilter = "&category=" + global.category;
    }

    spinner("preload-next");

    if (global.serverversion >= 4.16) {
        url =
            global.protocol +
            "://" +
            global.server +
            "/api/v1/token/catalog/apps/available/";
    } else {
        url =
            global.protocol + "://" + global.server + "/api/v1/token/catalog/apps/";
    }

    // queryAppsPage(
    //     url + "?cid=" + global.label["id"] + "&q=" + global.search + categoryFilter
    // );
    await waitForFlagApps();
    showAppItemNew(global.datos);
}

function normalizarTexto(texto) {
    return texto
        // Omitimos las mayúsculas eliminándolas: toLowerCase
        .toLowerCase()
        // Omitimos los acentos eliminándolos: normalize("NFD").replace(/[\u0300-\u036f]/g, "")
        .normalize("NFD").replace(/[\u0300-\u036f]/g, "")
        // Omitimos multiples espacios en blanco: replace(/  +/g, " ")
        .replace(/  +/g, " ")
}

function filteredListApps() {
    // Devolvemos la lista de aplicaciones que concuerdan con la búsqueda indicada en el input del formulario:
    let textoBusqueda = normalizarTexto($("#search").val());
    let listado = global.datos.filter((app, index) => {
        if (
            normalizarTexto(app.name)
                .includes(textoBusqueda) ||
            normalizarTexto(app.description)
                .includes(textoBusqueda) ||
            normalizarTexto(app.category_vitalinux.join(";"))
                .includes(textoBusqueda) ||
            normalizarTexto(app.levels.join(";"))
                .includes(textoBusqueda)
        ) {
            return app;
        }
    })
        // Ordenamos la lista de apps por nombre alfabéticamente
        .sort((a, b) => {
            // Convertir a minúsculas para asegurar que la comparación sea insensible a mayúsculas/minúsculas
            return a.name.toLowerCase().localeCompare(b.name.toLowerCase());
        });
    // return listado.slice(0, 10);
    return listado
}

async function queryApps() {
    $("#apps").html("");
    $("#preload-next").show();
    global.packages = "";

    var url = "";
    var categoryFilter = "";
    if (global.category != 0) {
        categoryFilter = "&category=" + global.category;
    }

    // spinner("preload-next");

    // if (global.serverversion >= 4.16) {
    //     url =
    //         global.protocol +
    //         "://" +
    //         global.server +
    //         "/api/v1/token/catalog/apps/available/";
    // } else {
    //     url =
    //         global.protocol + "://" + global.server + "/api/v1/token/catalog/apps/";
    // }

    // queryAppsPage(
    //     url + "?cid=" + global.label["id"] + "&q=" + global.search + categoryFilter
    // );
    // await waitForFlagApps();
    showAppItemNew(filteredListApps());
}